// $Id$

//=============================================================================
/**
 *  @file    trace_setup_message.cpp
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================
#define BEE_BUILD_DLL

#include "jyugem/cell/host_message.h"

namespace jyugem { namespace cell
{

void trace_setup_message::append(const any_item& mbr)
{
    TRACE_FUNCTION(TRL_LOW, "trace_setup_message::append");

    if (mbr.name() == "ENABLE")
    {
        m_enable = this->toBoolean(mbr);
    }
    else if (mbr.name() == "TRACE_ID")
    {
        m_traceid = (USHORT)mbr.m_value.getInt();
    }
    else if (mbr.name() == "FREQUENCY")
    {
        m_frequency = mbr.m_value.getInt();
    }
    else if (mbr.name() == "SAMPLE")
    {
        m_sample = (USHORT)mbr.m_value.getInt();
    }
    else if (mbr.name() == "REPORT_SIZE")
    {
        m_rptsize = (USHORT)mbr.m_value.getInt();
    }
    else if (mbr.name() == "DIR")
    {
        m_dir = mbr.m_value.toString();
    }
    else if (mbr.name() == "VARIABLE_ID")
    {
        m_vids.push_back(mbr.m_value.toString());
    }
    this->rcmd::append(mbr);
}

} }  // *jyugem::cell*
